import funki.text_colours as tc

φ = lambda x: ('\n' if '\n' in x else '') + f'{x}'

def fail(name, xyz):
  print('\n'.join([
    f"{tc.danger('FAIL')} {name}()",
    f"{tc.primary('Input       x_args:   ')} {φ(str(xyz['x_args']))}",
    f"{tc.primary('Expectation y_return: ')} {φ(str(xyz['y_return']))}",
    f"{tc.primary('Observation z_return: ')} {φ(str(xyz['z_return']))}",
    f"{tc.secondary('Input       x_stdi: ')} {φ(str(xyz['x_stdi']))}",
    f"{tc.secondary('Expectation y_stdo: ')} {φ(str(xyz['y_stdo']))}",
    f"{tc.secondary('Observation z_stdo: ')} {φ(str(xyz['z_stdo']))}",
  ]))
  return False

def property_failure(name, z_return):
  print('\n'.join([
    f"{tc.danger('FAIL')} {name}()",
    f"{tc.primary('Observation: ')} {φ(str(z_return))}",
  ]))
  return False

def success(name):
  print(f"{tc.success('PASS')} {name}()")
  return True
